--- lilo-22.8/bitmap.S	2005-11-23 22:38:40.000000000 +0100
+++ lilo-22.8/bitmap.S	2011-11-23 21:34:34.000000000 +0100
@@ -337,20 +337,29 @@
 	jmp	arr_vector
 
 	
-null:	mov	al,#1
-	cmp	ah,#0x50		; down arrow
-	je	arrow
+null:	mov	dx,[nimage]
 
-	neg	al
-	cmp	ah,#0x48		; up arrow
-	je	arrow
-
-	mov	dx,[nimage]
 	cmp	ah,#0x4f		; end
 	je	arr1
+	cmp	al,#0x47		; 'G'
+	je	arr1
 
 	cmp	ah,#0x47		; home
 	je	arr0
+	cmp	al,#0x67		; 'g'
+	je	arr0
+
+	mov	al,#1
+	cmp	ah,#0x50		; down arrow
+	je	arrow
+	cmp	ah,#0x24		; 'j'
+	je	arrow
+
+	neg	al
+	cmp	ah,#0x48		; up arrow
+	je	arrow
+	cmp	ah,#0x25		; 'k'
+	je	arrow
 
 	mov	al,[nrow]
 	xchg	ax,dx
@@ -377,7 +386,7 @@
 	jne	arr88
 	not	dh
 	add	al,dh
-	jmp	arrow
+	jmp	near arrow
 
 arr88:
 	neg	al
--- lilo-22.8/crt.S	2005-11-23 22:37:45.000000000 +0100
+++ lilo-22.8/crt.S	2011-11-23 21:34:28.000000000 +0100
@@ -431,20 +431,29 @@
 	jmp	arr_vector
 
 	
-null:	mov	al,#1
-	cmp	ah,#0x50		; down arrow
-	je	arrow
+null:	mov	dx,[nimage]
 
-	neg	al
-	cmp	ah,#0x48		; up arrow
-	je	arrow
-
-	mov	dx,[nimage]
 	cmp	ah,#0x4f		; end
 	je	arr1
+	cmp	al,#0x47		; 'G'
+	je	arr1
 
 	cmp	ah,#0x47		; home
 	je	arr0
+	cmp	al,#0x67		; 'g'
+	je	arr0
+
+	mov	al,#1
+	cmp	ah,#0x50		; down arrow
+	je	arrow
+	cmp	ah,#0x24		; 'j'
+	je	arrow
+
+	neg	al
+	cmp	ah,#0x48		; up arrow
+	je	arrow
+	cmp	ah,#0x25		; 'k'
+	je	arrow
 
 	mov	al,[nrow]
 	xchg	ax,dx
@@ -471,7 +480,7 @@
 	jne	arr88
 	not	dh
 	add	al,dh
-	jmp	arrow
+	jmp	near arrow
 
 arr88:
 	neg	al
--- lilo-22.8/second.S	2006-08-15 18:13:47.000000000 +0200
+++ lilo-22.8/second.S	2011-11-23 21:12:57.000000000 +0100
@@ -805,6 +805,17 @@
 #if defined(MENU) || defined(BITMAP)
 	cmp	al,#0xE0	; extended keyboard
 	je	toNull
+
+; Support for rudimentary vi bindings
+	cmp	al,#0x6A	; 'j'
+	je	toNull
+	cmp	al,#0x6B	; 'k'
+	je	toNull
+	cmp	al,#0x47	; 'G'
+	je	toNull
+	cmp	al,#0x67	; 'g'
+	je	toNull
+
 	or	al,al		;
 toNull:	je	near null	; cursor control
 #endif
@@ -849,7 +860,7 @@
 #endif
 	pop	bx
 	cmp	bx,#cmdline+1	; first character ?
-	jne	input		; no -> next input
+	jne	near input	; no -> next input
 #ifdef LCF_IGNORECASE
 	call	upcase		; convert to upper case
 #endif
